;;;; number-limits-test

(import test)

(import number-limits)
(import (chicken fixnum) (chicken flonum))

(print "** long long " (if (positive? long-long-size) "supported" "unsupported") " **")
(print "** unsigned long long " (if (positive? unsigned-long-long-size) "supported" "unsupported") " **")

#;(print "** long double " (if (fp= maximum-long-double maximum-long-double) "supported" "unsupported") " **")

(test-assert (fx= float-radix flonum-radix))
(test-assert (fp= maximum-double maximum-flonum))
(test-assert (fp= minimum-double minimum-flonum))

(print "            machine-word-bits: " machine-word-bits)
(print "       machine-word-precision: " machine-word-precision)
(print "maximum-unsigned-machine-word: " maximum-unsigned-machine-word)
(print "   most-negative-machine-word: " most-negative-machine-word)
(print "   most-positive-machine-word: " most-positive-machine-word)

(print "      unsigned-integer32-size: " unsigned-integer32-size)
(print "   maximum-unsigned-integer32: " maximum-unsigned-integer32)
(print "      most-negative-integer32: " most-negative-integer32)
(print "      most-positive-integer32: " most-positive-integer32)

(print "      unsigned-integer64-size: " unsigned-integer64-size)
(print "   maximum-unsigned-integer64: " maximum-unsigned-integer64)
(print "      most-negative-integer64: " most-negative-integer64)
(print "      most-positive-integer64: " most-positive-integer64)

(print "                    char-size: " char-size)
(print "           unsigned-char-size: " unsigned-char-size)
(print "                   short-size: " short-size)
(print "          unsigned-short-size: " unsigned-short-size)

(print "                    long-size: " long-size)
(print "           unsigned-long-size: " unsigned-long-size)
(print "               long-long-size: " long-long-size)
(print       "unsigned-long-long-size: " unsigned-long-long-size)
